import java.applet.*;
import java.awt.*;

public class Vypocet {
  Applet app;
  Retizek guma;

  int MAXX = 600, MAXY = 600;
  int pocet = 100; 
  double pruznost = 0.2, disipace = 0.98, d0 = 1, x, y;

  public Vypocet(Applet a, int mx, int my) {
    MAXX = mx;
    MAXY = my;
    app = a;
    guma = new Retizek(pocet, pruznost, disipace, d0);
    guma.srovnej(0, MAXY/2, (double)MAXX/(((double)guma.getPocet()-1)), 1);
    guma.setColor(Color.blue);
  }

  public void kresli() {
    Graphics g = app.getGraphics();
    Image offscreen;
    offscreen = app.createImage(MAXX, MAXY);
    Graphics os = offscreen.getGraphics();
    guma.prepocti();
    guma.posun();
    guma.okrajP(1, x, y);
//    guma.okrajL(1, 0, 0);

    guma.kresli(os);
    g.drawImage(offscreen, 0, 0, app);
  }

  public void setPruznost(double p) {
    pruznost = p;
    guma.setPruznost(p);
  }

  public void setDisipace(double d) {
    disipace = d;
    guma.setDisipace(d);
  }

  public void setD0(double d) {
    d0 = d;
    guma.setD0(d);
  }

  public void setXY(double xx, double yy) {
    x = xx;
    y = yy;
  }
}