import java.applet.*;
import java.awt.*;

public class Struny extends Applet
{
  Beh beh;
  Vypocet vyp;
  boolean ss = true;

  Label lpauza, lpruznost1, lpruznost2, lemitace, ldistance2, ldisipace2;
  Button tlstart, tlsrovnej;
//  Scrollbar sbpauza, sbpruznost, sbpocet;
  TextField tfpauza, tfpruznost1, tfpruznost2, tfdisipace2, tfdistance2;
  CheckboxGroup cbgokrajl, cbgokrajp;
  Checkbox cbokrajlp, cbokrajlv, cbokrajpp, cbokrajpv;
  Choice cemitor;
  Checkbox cbsmycka;
  
  final int MAXY = 200;
  int MAXX = 600;
  final int OFFS = 100;

  public Struny() {
  }

  public void init() {
    int mx = new Integer(getParameter("XSIZE")).intValue();
    if (mx >= 600) MAXX = mx;
    setLayout(null);
    setSize(MAXX, MAXY);
    vyp = new Vypocet(this, MAXX, MAXY-OFFS, 0, OFFS);
    beh = new Beh(vyp);

    lpauza = new Label("Pauza");
    lpruznost1 = new Label("Prunost 1");
    lpruznost2 = new Label("Prunost 2");
    ldisipace2 = new Label("Tlumen 2");
    lemitace = new Label("Emitace");
    ldistance2 = new Label("Napt 2");
    tlstart = new Button();
    tlstart.setLabel("Stop");
    tlsrovnej = new Button();
    tlsrovnej.setLabel("Srovnat");
//    sbpauza = new Scrollbar(Scrollbar.HORIZONTAL, 100, 50, 5, 500);
//    sbpruznost = new Scrollbar(Scrollbar.HORIZONTAL, 1000, 10, 0, 1000);
//    sbpocet = new Scrollbar(Scrollbar.HORIZONTAL, 20, 10, 2, 300);
    tfpauza = new TextField("50", 50);
    tfpruznost1 = new TextField("1", 50);
    tfpruznost2 = new TextField("1", 50);
    tfdisipace2 = new TextField("1", 50);
    tfdistance2 = new TextField("0", 50);
    cbgokrajl = new CheckboxGroup();
    cbgokrajp = new CheckboxGroup();
    cbokrajlp = new Checkbox("Pevn konec", cbgokrajl, true);
    cbokrajlv = new Checkbox("Voln konec", cbgokrajl, false);
    cbokrajpp = new Checkbox("Pevn konec", cbgokrajp, true);
    cbokrajpv = new Checkbox("Voln konec", cbgokrajp, false);
    cemitor = new Choice();
    cemitor.addItem("Trojhelnk");
    cemitor.addItem("Sinus");
    cemitor.addItem("Obdlnk");
    cbsmycka = new Checkbox("Smyka", false);

    lpauza.setBounds(0, 0, 70, 20);
    lpruznost1.setBounds(0, 20, 70, 20);
    lpruznost2.setBounds(170, 0, 70, 20);
    ldisipace2.setBounds(170, 20, 70, 20);
    ldistance2.setBounds(170, 40, 70, 20);
    lemitace.setBounds(MAXX-150, 20, 50, 20);
//    sbpauza.setBounds(0, 0, 200, 20);
//    sbpruznost.setBounds(0, 20, 200, 20);
//    sbpocet.setBounds(0, 40, 200, 20);
    tfpauza.setBounds(70, 0, 100, 20);
    tfpruznost1.setBounds(70, 20, 100, 20);
    tfpruznost2.setBounds(240, 0, 100, 20);
    tfdisipace2.setBounds(240, 20, 100, 20);
    tfdistance2.setBounds(240, 40, 100, 20);
    tlstart.setBounds(350, 0, 100, 20);
    tlsrovnej.setBounds(350, 20, 100, 20);
    cbokrajlp.setBounds(0, 60, 100, 20);
    cbokrajlv.setBounds(0, 80, 100, 20);
    cbokrajpp.setBounds(MAXX-100, 60, 100, 20);
    cbokrajpv.setBounds(MAXX-100, 80, 100, 20);
    cemitor.setBounds(MAXX-100, 20, 100, 20);
    cbsmycka.setBounds(MAXX-100, 40, 100, 20);
   

    add(lpauza);
    add(lpruznost1);
    add(lpruznost2);
    add(ldisipace2);
    add(lemitace);
    add(ldistance2);
//    add(sbpauza);
//    add(sbpruznost);
//    add(sbpocet);
    add(tfpauza);
    add(tfpruznost1);
    add(tfpruznost2);
    add(tfdisipace2);
    add(tfdistance2);
    add(tlstart);
    add(tlsrovnej);
    add(cbokrajlp);
    add(cbokrajlv);
    add(cbokrajpp);
    add(cbokrajpv);
    add(cemitor);
    add(cbsmycka);
  }

  public void start() {
    beh.start();
  }

  public void stop() {
    beh.stop();
  }

  public void paint() {
    vyp.kresli();
  }

/*
  public boolean handleEvent(Event evt) {
    if (evt.target == sbpauza) {
      beh.setPause(sbpauza.getValue());
    }

    if (evt.target == sbpruznost) {
      vyp.setPruznost((double)sbpruznost.getValue()/1000);
    }

    if (evt.target == sbpocet) {
      vyp.setPocet(sbpocet.getValue());
    }
    return true;
  }
*/

  public boolean action(Event evt, Object obj) {

    if (evt.target == tlsrovnej) {
      vyp.srovnej();
    }

    if (evt.target == tlstart) {
      if (ss) tlstart.setLabel("Start");
      else tlstart.setLabel("Stop");
      if (ss) ss = false;
      else ss = true;
      beh.setBeh(ss);
    }

    if (evt.target == tfpauza) {
      int i = new Integer((String)obj).intValue();
      if (i >= 0) beh.setPause(i);
    }

    if (evt.target == tfpruznost1) {
      double d = new Double((String)obj).doubleValue();
      if ((d > 0) && (d <= 1)) vyp.setPruznostL(d);
    }

    if (evt.target == tfpruznost2) {
      double d = new Double((String)obj).doubleValue();
      if ((d > 0) && (d <= 1)) vyp.setPruznostP(d);
    }

    if (evt.target == tfdisipace2) {
      double d = new Double((String)obj).doubleValue();
      if ((d > 0) && (d <= 1)) vyp.setDisipace(d);
    }

    if (evt.target == tfdistance2) {
      double d = new Double((String)obj).doubleValue();
      vyp.setD0(d);
    }

    if (evt.target == cbokrajlp) {
      vyp.setOkrajL(1);
    }

    if (evt.target == cbokrajlv) {
      vyp.setOkrajL(2);
    }

    if (evt.target == cbokrajpp) {
      vyp.setOkrajP(1);
    }

    if (evt.target == cbokrajpv) {
      vyp.setOkrajP(2);
    }

    if (evt.target == cemitor) {
      if ((String)obj == "Trojhelnk") vyp.setEmitace(true, 1);
      if ((String)obj == "Sinus") vyp.setEmitace(true, 2);
      if ((String)obj == "Obdlnk") vyp.setEmitace(true, 3);
    }

    if (evt.target == cbsmycka) {
      vyp.swapSmycka();
    }

    return true;
  }
}
